external readline : string -> string = "readline_stub"
external readline_init : string -> unit = "readline_init_stub"
external add_completion_string : string -> unit = "add_completion_string"

type rl_buf = {
  mutable buf : string;
  mutable len : int;
  mutable pos : int;
}

let stream_reader prompt =
  let buf = { buf = ""; len = 0; pos = 0 } in
  let readline_stream_f s n =
    if buf.len <= buf.pos then
      (let input = readline (prompt ()) ^ "\n" in
	 buf.buf <- input;
	 buf.pos <- 0;
	 buf.len <- String.length input);
    let size = min (buf.len - buf.pos) n in
      String.blit buf.buf buf.pos s 0 size;
      buf.pos <- buf.pos + size;
      size
  in readline_stream_f

	
